<?php if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly ?>
<?php

$success_message = '';
$error_message = '';

// ====================================================
// Include the file that contains all the info
// ====================================================

include('settings.php');

// getting the page url for the settings page
$plugin_page_url = esc_url( menu_page_url( 'yydev-tag-manager', false ) );

// ====================================================
// Update the data if it's changed
// ====================================================

if( isset($_POST['yydev_tagmanager_nonce']) ) {

    if( wp_verify_nonce($_POST['yydev_tagmanager_nonce'], 'yydev_tagmanager_action') ) {

        // If there is no error insert the info to the database
        $form_shortcode_head = yydev_tagmanager_mysql_prep($_POST['form_shortcode_head']);
        $form_shortcode_body = yydev_tagmanager_mysql_prep($_POST['form_shortcode_body']);
        $form_shortcode_footer = yydev_tagmanager_mysql_prep($_POST['form_shortcode_footer']);

        $add_plugin_to_menu = 0;
        if( isset($_POST['add_plugin_to_menu']) ) {
            $add_plugin_to_menu = intval( $_POST['add_plugin_to_menu'] );
        } // if( isset($_POST['add_plugin_to_menu']) ) {

        $yydev_tag_mangage_wp_body_open = 0;
        if( isset($_POST['yydev_tag_mangage_wp_body_open']) ) {
            $yydev_tag_mangage_wp_body_open = intval( $_POST['yydev_tag_mangage_wp_body_open'] );
        } // if( isset($_POST['yydev_tag_mangage_wp_body_open']) ) {

        $current_page_id = "0";

        // update the why we display the menu from the main admin panel or under settings
        update_option($menu_loading_name, $add_plugin_to_menu);
        
        // update the way the body tag is getting loaded on the theme
        update_option('yydev_tag_mangage_wp_body_open', $yydev_tag_mangage_wp_body_open);

        $check_if_data_exists = $wpdb->get_row("SELECT id FROM " . $yydev_tags_table_name . " WHERE page_id = 0");

        if( $wpdb->num_rows == 0) {

            // if the data was not submited into the database
            $wpdb->insert( $yydev_tags_table_name, array('page_id'=>$current_page_id, 'tag_type'=>'head', 'tag_code'=>$form_shortcode_head), array('%d', '%s', '%s') );
            $wpdb->insert( $yydev_tags_table_name, array('page_id'=>$current_page_id, 'tag_type'=>'body', 'tag_code'=>$form_shortcode_body), array('%d', '%s', '%s') );
            $wpdb->insert( $yydev_tags_table_name, array('page_id'=>$current_page_id, 'tag_type'=>'footer', 'tag_code'=>$form_shortcode_footer), array('%d', '%s', '%s') );

            // Creating page link and redirect the user the current page with the new data
            $success_message = __('The data was inserted successfully', 'tag-manager-header-body-footer');
            $new_page_link = $plugin_page_url . "&message=" . urlencode($success_message);

        } else { // if( $wpdb->num_rows == 0) {

            // if the data already exist one the database
            $wpdb->update( $yydev_tags_table_name, array('tag_code'=>$form_shortcode_head), array('page_id'=>$current_page_id, 'tag_type'=>'head'), array('%s') );
            $wpdb->update( $yydev_tags_table_name, array('tag_code'=>$form_shortcode_body), array('page_id'=>$current_page_id, 'tag_type'=>'body'), array('%s') );
            $wpdb->update( $yydev_tags_table_name, array('tag_code'=>$form_shortcode_footer), array('page_id'=>$current_page_id, 'tag_type'=>'footer'), array('%s') );

            // Creating page link and redirect the user the current page with the new data
            $success_message = __('The data was updated successfully', 'tag-manager-header-body-footer');
            $new_page_link = $plugin_page_url . "&&plugin_redirect=1&message=" . urlencode($success_message);

        } // } else { // if( $wpdb->num_rows == 0) { 
                  
        // getting the page url for the settings page

    } else { // if( wp_verify_nonce($_POST['yydev_tagmanager_nonce'], 'yydev_tagmanager_action') ) {
        $error_message = __('Error: form nonce problem', 'tag-manager-header-body-footer');
    } // } else { // if( wp_verify_nonce($_POST['yydev_tagmanager_nonce'], 'yydev_tagmanager_action') ) {

} // if( isset($_POST['yydev_tagmanager_nonce']) ) {

?>

<div class="wrap yydevelopment-tag-manager">

    <h2 class="display-inline"><?php _e('Tag Manager - Add Header, Body and Footer Codes', 'tag-manager-header-body-footer'); ?></h2>
    <p class="main-plugin-description"><?php esc_html_e('Below you will be able to add header code, below the <body> code and footer code for tracking platforms like google analytics, facebook pixel and google tag manager.', 'tag-manager-header-body-footer'); ?></p>

    <?php yydev_tagmanager_echo_message_if_exists(); ?>
    <?php yydev_tagmanager_echo_success_message_if_exists($success_message); ?>
    <?php yydev_tagmanager_echo_error_message_if_exists($error_message); ?>

    <div class="insert-new">
        
<?php

    $tagmanager_content = $wpdb->get_results("SELECT * FROM " . $yydev_tags_table_name . " WHERE page_id = 0");
    $head_tag = ''; $body_tag = ''; $footer_tag = '';

    if($tagmanager_content > 0) {  

        foreach($tagmanager_content as $tagmanager_content_data) {

            $tag_type = $tagmanager_content_data->tag_type;
            $tag_code = $tagmanager_content_data->tag_code;
            
            if( $tag_type === "head" ) {
                $head_tag = $tagmanager_content_data->tag_code;
            } elseif( $tag_type === "body" ) {
                $body_tag = $tagmanager_content_data->tag_code;
            } elseif( $tag_type === "footer" ) {
                $footer_tag = $tagmanager_content_data->tag_code;
            } // if( $tag_type === "head" ) {

        } // foreach($tagmanager_content as $tagmanager_content_data) {

    } // if($tagmanager_content > 0) {  

?>

<br />

<form class="edit-form-data" method="POST" action="">

        <div class="yydev_tag_warp_textarea">
            <p><b><?php esc_html_e('Insert <head> tags code', 'tag-manager-header-body-footer'); ?></b> - 
            <span><?php esc_html_e('The code will be displayed between the opening <head> and the closing </head> tags', 'tag-manager-header-body-footer'); ?></span></p>
            <textarea class='form_shortcode_content' name='form_shortcode_head' ><?php echo esc_attr($head_tag); ?></textarea>
        </div><!--yydev_tag_warp_textarea-->
            
        <div class="yydev_tag_warp_textarea">
            <p><b><?php esc_html_e('Insert tags after <body> opening tag', 'tag-manager-header-body-footer'); ?></b> - 
            <?php esc_html_e('The code will be displayed below the opening <body> tag', 'tag-manager-header-body-footer'); ?></p>
            <textarea class='form_shortcode_content' name='form_shortcode_body' ><?php echo esc_attr($body_tag); ?></textarea>
        </div><!--yydev_tag_warp_textarea-->

        <div class="yydev_tag_warp_textarea">
            <p><b><?php esc_html_e('Insert footer tags code', 'tag-manager-header-body-footer'); ?></b> - 
            <?php esc_html_e('The code will be displayed right above the end </body> tag', 'tag-manager-header-body-footer'); ?></p>
            <textarea class='form_shortcode_content' name='form_shortcode_footer' ><?php echo esc_attr($footer_tag); ?></textarea>
        </div><!--yydev_tag_warp_textarea-->

        <input type="checkbox" name="add_plugin_to_menu" id="add_plugin_to_menu" value='1' <?php if( intval( get_option($menu_loading_name) ) == 1) { echo 'checked'; } ?>/> 
        <label for="add_plugin_to_menu"><?php _e('Check this box if you want the plugin to show up under the settings menu instead of the main menu (require reopening the plugin page to see changes)', 'tag-manager-header-body-footer'); ?></label>

        <br /><br />

        <input type="checkbox" name="yydev_tag_mangage_wp_body_open" id="yydev_tag_mangage_wp_body_open" value='1' <?php if( intval( get_option('yydev_tag_mangage_wp_body_open') ) == 1) { echo 'checked'; } ?>/> 
        <label for="yydev_tag_mangage_wp_body_open"><?php _e('Check this if your theme supports <b>wp_body_open</b> action (make the way the body tag getting loaded faster)', 'tag-manager-header-body-footer'); ?></label>

        <br />

        <?php
            // creating nonce to make sure the form was submitted correctly from the right page
            wp_nonce_field( 'yydev_tagmanager_action', 'yydev_tagmanager_nonce' ); 
        ?>

        <input type="submit" class="edit-form-data yydev-tags-submit" name="insert_tag_manager" value="<?php _e('Insert/Update Tags', 'tag-manager-header-body-footer'); ?>" />

</form>

<br /><br /><br />
<span id="footer-thankyou-code"><?php _e('This plugin was created by', 'tag-manager-header-body-footer'); ?> <a target="_blank" href="https://www.yydevelopment.com">YYDevelopment</a>. 
<?php _e('If you liked it please give it a', 'tag-manager-header-body-footer'); ?> <a target="_blank" href="https://wordpress.org/plugins/tag-manager-header-body-footer/#reviews"><?php _e('5 stars review', 'tag-manager-header-body-footer'); ?></a>.</span>
</div><!--wrap-->